# -*- coding: utf-8 -*- 

import uno
import unohelper
from itertools import chain
from org.openoffice.sheet.addin import XPyString


class PyString(unohelper.Base, XPyString):
    def __init__(self, ctx):
        self.ctx = ctx

    def pystring(self, method, basestring, param1, param2, param3):
        def _translate(string):
            p1 = chain.from_iterable(param1)
            p2 = chain.from_iterable(param2)
            table = {ord(c):(ord(t) if t else None) for c, t in zip(p1,p2)}
            return string.translate(table)

        def _getattr(string):
            args = [p for p in (param1, param2, param3) if p is not None]
            r = getattr(string, method)(*args)
            if type(r)==list:
                r = tuple(r)
            elif type(r)==bool:
                r = int(r)
            return r

        def _format(string):
            kwargs = {}
            p1 = args = type(param1)==tuple and chain.from_iterable(param1) or (param1,)
            if param2:
                p2 = type(param2)==tuple and chain.from_iterable(param2) or (param2,)
            if param3:
                p3 = type(param3)==tuple and chain.from_iterable(param3) or (param3,)
                kwargs = {k:v for k,v in zip(p2,p3)}
            elif param2:
                kwargs = {k:v for k,v in zip(p1,p2)}
            return string.format(*args, **kwargs)

        method = method.lower()
        res = []
        # problème de conversion int/float/0.0/0 :((
        try:
            param1 = (param1 % 1) and param1 or int(param1)
        except TypeError:
            pass
        try:
            param2 = (param2 % 1) and param2 or int(param2)
        except TypeError:
            pass
        try:
            param3 = (param3 % 1) and param3 or int(param3)
        except TypeError:
            pass
        if method == "join":
            sep = param1 or " "
            s = tuple(chain.from_iterable(basestring))
            if len(s)==1: s = s[0]
            res.append(sep.join(s))
            return (tuple(res),)
        else:
            for row in basestring:
                if method == "format":
                    res.append( tuple(_format(col) for col in row) )
                elif method == "translate":
                    res.append( tuple(_translate(col) for col in row) )
                else:
                    res.append( tuple(_getattr(col) for col in row) )
            if type(res[0][0])==tuple:
                return tuple(r[0] for r in res)
            else:
                return tuple(res)




def createInstance(ctx):
    return PyString(ctx)
g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation( \
        createInstance,"org.openoffice.pyfunctions.PyString",
                ("com.sun.star.sheet.AddIn",),)